#include "bp_filter.h"
#include "TMath.h"//Pi()
#include <iostream>

using namespace std;

Filter::Filter(){;}

Filter::~Filter(){;}

double Filter::operator()(double ){
  return 1;
}

linearFilter::linearFilter():Filter(){;}

linearFilter::~linearFilter(){;}

double linearFilter::operator()(double f){
  return f;
}

wienerFilter::wienerFilter(double _f0, double _g):
  Filter(),f0(_f0),g(_g){}

wienerFilter::~wienerFilter(){}

double wienerFilter::operator()(double f){
  return f/(g+(f/f0)*(f/f0));
}

hanningFilter::hanningFilter(double _alpha):
  Filter(),alpha(_alpha){;}

hanningFilter::~hanningFilter(){;}

double hanningFilter::operator()(double f){
  double v=alpha+(1-alpha)*cos(TMath::Pi()*f);
  if (v<0) return 0;
  cout<<f<<' '<<v<<endl;
  return f*v;
}


cutoffFilter::cutoffFilter(double _f0):Filter(),f0(_f0){;}

cutoffFilter::~cutoffFilter(){;}

double cutoffFilter::operator()(double f){
  if (f>f0) return 0;
  return 1;
}

histoFilter::histoFilter(TH1D *h):data(h){}

histoFilter::~histoFilter(){;}

double histoFilter::operator()(double f){
  double n=f*data->GetNbinsX();
  if (n<0.5) return (*data)[1];
  if (n>data->GetNbinsX()-0.5) return (*data)[data->GetNbinsX()];
  n-=0.5;//to 0..n-1 range
  int b=static_cast<int>(floor(n));
  if (b==data->GetNbinsX()-1) b-=1;
  double q=n-b;
  return (1-q)*(*data)[b+1]+q*(*data)[b+2];
}
