#ifndef __BACK_PROJECTION_FILTER_
#define __BACK_PROJECTION_FILTER_
#include "TH1D.h"

class Filter{
  //assume a scaled frequency between 0 and 1 for max frequency as the argument to operator()
 public:
  Filter();
  virtual ~Filter();
  virtual double operator()(double f);
};

class linearFilter:public Filter{
 public:
  linearFilter();
  virtual ~linearFilter();
  virtual double operator()(double f);
};

class wienerFilter:public Filter{


 public:
  wienerFilter(double f0, double g);
  virtual ~wienerFilter();
  virtual double operator()(double f);
 private:
  double f0;
  double g;
};

class hanningFilter:public Filter{
 public:
  hanningFilter(double alpha);
  virtual ~hanningFilter();
  virtual double operator()(double f);
 private:
  double alpha;
};

//a simple filter that cuts anything beyond a certain frequency f0
class cutoffFilter:public Filter{
 public:
  cutoffFilter(double f0);
  virtual ~cutoffFilter();
  virtual double operator()(double f);
 private:
  double f0;
};

class histoFilter:public Filter{
 public:
  histoFilter(TH1D *data);
  virtual ~histoFilter();
  virtual double operator()(double f);
 private:
  TH1D *data;
};

#endif
