#ifndef __DO_FFT_ROOT__
#define __DO_FFT_ROOT__

#include "doFFT.h"

class FFTdata_ROOT:public FFTdata{
public:
  FFTdata_ROOT();
  virtual ~FFTdata_ROOT();
  virtual void Transform(const TH1D *h1);
  virtual void InverseTransform(TH1D *h1);
  virtual void ApplyFilter(Filter *f);

  //some manipulation in omega space
  virtual void Divide (const FFTdata &);
  virtual void Multiply(const FFTdata&);

  TH1D *GetKspaceReal() const {return hKspaceReal;}
  TH1D *GetKspaceImaginary() const {return hKspaceImaginary;}
  TH1D *GetRspaceReal() const {return hRspaceReal;}
  TH1D *GetPowerSpectrum(TH1D *placeHolder);

 private:
  //transform from R to K. For transform, hRspaceReal is filled with
  //data, and transformed function is filled to hKspaceReal and
  //hKspaceComples; for inverse transform data from hKspaceReal and
  //hKspaceComplex is filled back into hRspaceReal
  TH1D *hKspaceReal;
  TH1D *hKspaceImaginary;
  TH1D *hRspaceReal;
};

#endif
